#include "stdafx.h"
#include "msPlugInImpl.h"
#include "msLib.h"

#define VER "RAX Exporter  0.37 by hyun..."

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved	
		       )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}



cMsPlugIn*	CreatePlugIn ()
{
    return new cPlugIn ();
}



cPlugIn::cPlugIn ()
{
    strcpy (szTitle, VER);
}



cPlugIn::~cPlugIn ()
{
}



int	cPlugIn::GetType ()
{
    return cMsPlugIn::eTypeExport;
}



const char*	cPlugIn::GetTitle ()
{
    return szTitle;
}



int	cPlugIn::Execute (msModel *pModel)
{
    if (!pModel)
        return -1;

    //
    // check, if we have something to export
    //
    if (msModel_GetMeshCount (pModel) == 0)
    {
        ::MessageBox (NULL, "The model is empty!  Nothing exported!", "RAW Export", MB_OK | MB_ICONWARNING);
        return 0;
    }
 	

    //
    // choose filename
    //
    OPENFILENAME ofn;
    memset (&ofn, 0, sizeof (OPENFILENAME));
    
    char szFile[MS_MAX_PATH];
    char szFileTitle[MS_MAX_PATH];
    char szDefExt[32] = "rax";
    char szFilter[128] = "RAX Files (*.rax)\0*.rax\0All Files (*.*)\0*.*\0\0";
    szFile[0] = '\0';
    szFileTitle[0] = '\0';

    ofn.lStructSize = sizeof (OPENFILENAME);
    ofn.lpstrDefExt = szDefExt;
    ofn.lpstrFilter = szFilter;
    ofn.lpstrFile = szFile;
    ofn.nMaxFile = MS_MAX_PATH;
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nMaxFileTitle = MS_MAX_PATH;
    ofn.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;
    ofn.lpstrTitle = "Export RAX";

    if (!::GetSaveFileName (&ofn))
        return 0;

    //
    // export
    //
    FILE *file = fopen (szFile, "wt");
    if (!file)
        return -1;

    int i, j ;
    int joint_n;
    int mesh_n;
    int material_n;
    int n,index;
    msVec3 vec3;
    char szName[64],szName2[64];
    int vertex_n[128];

    int vertex_total_n,triangle_total_n;

    msBone *pBone;
//int           msModel_GetFrame (msModel *pModel);
//int           msModel_GetTotalFrames (msModel *pModel);
//int           msModel_FindBoneByName (msModel *pModel, const char *szName);

    mesh_n=msModel_GetMeshCount (pModel); 
    joint_n=msModel_GetBoneCount (pModel);
    material_n=msModel_GetMaterialCount (pModel);

  
    // count total vertex & triangle number !
    vertex_total_n=0;
    triangle_total_n=0;
    for (i = 0; i < mesh_n ; i++)
    {
	    msMesh *pMesh = msModel_GetMeshAt (pModel, i);
	    vertex_total_n+= msMesh_GetVertexCount (pMesh);
	    triangle_total_n+=msMesh_GetTriangleCount (pMesh);
    }


    for (i = 0; i < joint_n; i++)
	    vertex_n[i]=0;


    // get the vertex_n of a bone 
    for (i = 0; i < mesh_n ; i++)
    {
	msMesh *pMesh = msModel_GetMeshAt (pModel, i);
	msVertex *pVertex;
	
	n= msMesh_GetVertexCount (pMesh);
	for (j = 0; j < n; j++)
	{
		pVertex=msMesh_GetVertexAt(pMesh,j);
		index=msVertex_GetBoneIndex(pVertex);
		vertex_n[index]++;
	}
    }



    fprintf (file, "//  "VER"\n");
    fprintf (file, "//  For Animation Joint Vertex !! \n");
    fprintf (file, "//  Mesh(Shape)_count= %d\n\n",mesh_n);
   

    fprintf (file, "Bone= %d \n",joint_n);
    fprintf (file, "{\n ");
    for (i = 0; i < joint_n; i++)
    {
	    msBone *pBone = msModel_GetBoneAt (pModel, i);
	    msBone_GetName (pBone, szName, 64);

	    msBone_GetParentName(pBone,szName2,64);
	    index=msModel_FindBoneByName (pModel,szName2);
	    fprintf (file, "\t index= %2d   parent= %2d  vertex_n= %3d   \"%s\" \n ",i,index,vertex_n[i],szName);
	    //fprintf (file, "boneIndex=%d  boneName=\"%s\" ",i,szName);
    }
    fprintf (file, "}\n\n");

    fprintf (file, "Joint= %d \n",joint_n);
    fprintf (file, "{\n ");
    for (j = 0; j < joint_n; j++)
    {
	    msBone *pBone = msModel_GetBoneAt (pModel, j);
	    msBone_GetPosition(pBone,vec3);
	    fprintf (file, "\t%d  %f %f %f   ",j, vec3[0], vec3[1], vec3[2]);
	    msBone_GetRotation(pBone,vec3);
	    fprintf (file, "\t%f %f %f \n", vec3[0], vec3[1], vec3[2]);
    }
    fprintf (file, "}\n\n");
    

    // MSLIB_API int           msModel_GetMaterialCount (msModel *pModel);
    // MSLIB_API msMaterial*   msModel_GetMaterialAt (msModel *pModel, int nIndex);
    fprintf (file, "Material = %d\n", material_n);
    fprintf (file, "{\n");
    for (i = 0; i < material_n; i++)
    {
	    msMaterial  *pMaterial= msModel_GetMaterialAt (pModel, i);
	    msMaterial_GetName (pMaterial, szName, 64);
	    fprintf (file, "\t%d  %s\n",i, szName);

    }
    fprintf (file, "}\n\n");


    int vertex_i=0;
    int triangle_n=0;
    int last_vertex_n[16];
    int last_triangle_n[16];

  
    fprintf (file, "Vertex= %d\n", vertex_total_n);
    fprintf (file, "{\n");
  	
    for (i = 0; i < mesh_n ; i++)
    {
	    char szName[64];
		
	    msMesh *pMesh = msModel_GetMeshAt (pModel, i);
	    msMesh_GetName (pMesh, szName, 64);

	    msVertex *pVertex;
	    msVec2    tex;

	    last_vertex_n[i]=vertex_i;
	    n= msMesh_GetVertexCount (pMesh);

	    for (j=0; j < n; j++)
	    {
		    pVertex=msMesh_GetVertexAt(pMesh,j);
		    msVertex_GetTexCoords (pVertex,tex);
		    index=msVertex_GetBoneIndex(pVertex);

		    //	  x y z  u v  bone_index  
		    fprintf (file, "\t%d   %f %f %f %f %f %d \n",vertex_i, pVertex->Vertex[0], pVertex->Vertex[1], pVertex->Vertex[2],tex[0],tex[1],index);
		    vertex_i++;
	    }

    }
    fprintf (file, "}\n\n");
   
   	
    fprintf (file, "Triangle= %d\n", triangle_total_n);
    fprintf (file, "{\n");

    for (i = 0; i < mesh_n ; i++)
    {
	    msMesh *pMesh = msModel_GetMeshAt (pModel, i);


	    n=msMesh_GetTriangleCount (pMesh);
	    for (j = 0; j < n; j++)
	    {
		    msTriangle *pTriangle = msMesh_GetTriangleAt (pMesh, j);
		    word nIndices[3];
		    msTriangle_GetVertexIndices (pTriangle, nIndices);
			// index   v1 v2 v3  texture_id 
		    fprintf (file, "\t%d   %d %d %d  %d\n",triangle_n,
				    nIndices[0]+last_vertex_n[i],
				    nIndices[1]+last_vertex_n[i],
				    nIndices[2]+last_vertex_n[i],i);
		    triangle_n++;
	    }


    }
    fprintf (file, "}\n");
	
    fclose (file);
  
    // dont' forget to destroy the model
    msModel_Destroy (pModel);
    return 0;
}


///        fprintf (file, "Shape(Mesh)_Name=  %s\n", szName);
	
	//msMesh_GetVertexCount (msMesh *pMesh);
	//msVertex*     msMesh_GetVertexAt (msMesh *pMesh, int nIndex);
	//int           msVertex_GetBoneIndex (msVertex* pVertex);
	//void          msVertex_GetTexCoords (msVertex* pVertex, msVec2 st);
	
//	    for(k=0;k<3;k++)	    {
//	    pVertex = msMesh_GetVertexAt (pMesh, nIndices[k]);
//	    fprintf (file, "%f %f %f  ", pVertex->Vertex[0], pVertex->Vertex[1], pVertex->Vertex[2]);
//	    msVertex_GetTexCoords (pVertex, tex);
//	    fprintf (file, "	%f %f \n", tex[0], tex[1]);
//	    }
//  			  msVertex_SetTexCoords (msVertex* pVertex, msVec2 st);
//MSLIB_API void          msVertex_GetTexCoords (msVertex* pVertex, msVec2 st);
//MSLIB_API int           msVertex_SetBoneIndex (msVertex* pVertex, int nBoneIndex);
//MSLIB_API int           msVertex_GetBoneIndex 

